DECLARE FUNCTION fAsciiHexToBinary% (StringToConvert AS STRING)
DECLARE FUNCTION fBinaryToAsciiHex$ (ByteToConvert AS INTEGER)
DECLARE SUB ConfigurePort ()
DECLARE SUB DisplayData (DataToDisplay AS STRING)
DECLARE SUB DisplayReceivedData ()
DECLARE SUB NodeActivities ()

DIM SHARED BitRate AS INTEGER
DIM SHARED BitRateString AS STRING
DIM SHARED ComPortAddress AS INTEGER
DIM SHARED ComPortAddressString AS STRING
DIM SHARED ComPortNumber AS INTEGER
DIM SHARED ComPortNumberString AS STRING
DIM SHARED DataIn AS STRING
DIM SHARED DataOut AS STRING

DIM Count AS INTEGER

CONST true = -1
CONST false = NOT true

'This program uses the serial port to exchange data with another computer.

ON ERROR GOTO ErrorHandler

CALL ConfigurePort
'The OPEN statement initializes the selected COM port & sets communications
'parameters: bit rate, no parity, 8 data bits, 1 stop bit, no handshaking.
'It also enables the receive-data interrupt.
OPEN "COM" + ComPortNumberString + ": " + BitRateString + ",n,8,1,bin,cs0,ds0,cd0" FOR RANDOM AS #1

COM(ComPortNumber) ON
PRINT "waiting for data"
ON COM(ComPortNumber) GOSUB ReadSerialPort

DO
	CALL NodeActivities
LOOP WHILE INKEY$ = ""
CLOSE #1
END

ReadSerialPort:
'Read 8 bytes from the serial-port buffer
IF LOC(1) >= 8 THEN
	DataIn = INPUT$(LOC(1), #1)
	PRINT "Data in:"
	CALL DisplayData(DataIn)
	GOSUB SendData
END IF
RETURN

SendData:
PRINT #1, DataOut
PRINT "Data out:"
CALL DisplayData(DataOut)
RETURN

ErrorHandler:
'Display errors for troubleshooting:
PRINT "error=", ERR
RESUME NEXT
RETURN


SUB ConfigurePort
'Display the COM port number, address, and bit rate
'and allow user to change them.
DIM Response AS STRING
ComPortNumberString = "2"
ComPortAddressString = "2F8"
BitRateString = "2400"
'Display the settings and allow user to change them.
CLS
PRINT "Current COM port settings are:"
PRINT "Port Number = ", ComPortNumberString
PRINT "Base Address = ", ComPortAddressString
PRINT "BitRate = ", BitRateString
PRINT "OK? Y/N (Y)"
Response = INPUT$(1)
PRINT Response
SELECT CASE Response
	CASE "N", "n"
		INPUT "Port Number:  ", ComPortNumberString
		INPUT "Base Address:  ", ComPortAddressString
		ComPortAddressString = UCASE$(ComPortAddressString)
		'If the user adds a trailing "H", remove it.
		SELECT CASE RIGHT$(ComPortAddressString, 1)
			CASE "H"
				ComPortAddressString = LEFT$(ComPortAddressString, LEN(ComPortAddressString) - 1)
			CASE ELSE
		END SELECT
		INPUT "BitRate:  ", BitRateString
CASE ELSE
END SELECT

'Get the values of the strings.
ComPortNumber = VAL(ComPortNumberString)
ComPortAddress = VAL("&h" + ComPortAddressString)
BitRate = VAL(BitRateString)
END SUB

SUB DisplayData (DataToDisplay AS STRING)
DIM Count  AS INTEGER
PRINT "Text:     ";
FOR Count = 1 TO 8
	PRINT USING "\  \"; MID$(DataToDisplay, Count, 1);
NEXT Count
PRINT
PRINT "Decimal: ";
FOR Count = 1 TO 8
	PRINT USING "\  \"; STR$(ASC((MID$(DataToDisplay, Count, 1))));
NEXT Count
PRINT
PRINT "Hex:      ";
FOR Count = 1 TO 8
	PRINT USING "\  \"; fBinaryToAsciiHex((ASC(MID$(DataToDisplay, Count, 1))));
NEXT Count
PRINT
END SUB

FUNCTION fAsciiHexToBinary% (StringToConvert AS STRING)
'Converts a 2-byte ASCII hex string to its byte value
 fAsciiHexToBinary = VAL("&h" + StringToConvert)
END FUNCTION

FUNCTION fBinaryToAsciiHex$ (ByteToConvert AS INTEGER)
'Converts a binary value to a 2-character ASCII hex string.
DIM Result AS STRING
Result = HEX$(ByteToConvert)
IF LEN(Result) < 2 THEN
	DO
		Result = "0" + Result
	LOOP UNTIL LEN(Result) = 2
END IF
fBinaryToAsciiHex = Result

END FUNCTION

SUB NodeActivities
'Perform any other activities the node is responsible for.                                                                                                                                                                                                            
'Use current time as test data:
DataOut = TIME$
END SUB

