VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form frmMain 
   Caption         =   "Serial Port Complete"
   ClientHeight    =   1428
   ClientLeft      =   132
   ClientTop       =   420
   ClientWidth     =   2976
   LinkTopic       =   "Form1"
   ScaleHeight     =   1428
   ScaleWidth      =   2976
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer tmrTransferInterval 
      Left            =   1200
      Top             =   3960
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   120
      Top             =   3840
      _ExtentX        =   804
      _ExtentY        =   804
      _Version        =   327681
      DTREnable       =   -1  'True
   End
   Begin VB.Timer tmrTimeout 
      Enabled         =   0   'False
      Interval        =   200
      Left            =   720
      Top             =   3960
   End
   Begin VB.Menu mnuSetup 
      Caption         =   "Setup"
      Index           =   0
      Begin VB.Menu mnuPortSettings 
         Caption         =   "Port Settings"
         Index           =   0
         Shortcut        =   ^P
      End
      Begin VB.Menu mnuDataFile 
         Caption         =   "Data File"
         Index           =   1
         Shortcut        =   ^D
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'General-purpose template for applications
'that access serial ports.

Private Sub Form_Load()
Show
Call Startup
End Sub

Private Sub Form_Unload(Cancel As Integer)
Call ShutDown
End
End Sub

Private Sub mnuDataFile_Click(Index As Integer)
frmDataFile.Show
End Sub

Private Sub mnuPortSettings_Click(Index As Integer)
frmPortSettings.Show
End Sub

Public Function fncInitializeComPort _
    (BitRate As Long, _
    PortNumber As Integer) _
    As Boolean
'Initializes the selected Com Port.
'All settings except BitRate are set explicitly in this routine.
'Some properties show alternate settings commented out.
Dim ComSettings$

If MSComm1.PortOpen = True Then
    MSComm1.PortOpen = False
End If

MSComm1.CommPort = PortNumber
'Use BitRate, no parity, 8 data, and 1 stop bit:
ComSettings = CStr(BitRate) & ",N,8,1"
MSComm1.Settings = ComSettings

'Properties relating to receiving:
'Read entire buffer on Input:
MSComm1.InputLen = 0
'Read one byte at a time on Input:
'MSComm1.InputLen = 1

MSComm1.InBufferSize = 1024

'Generate no OnComm event on received data:
MSComm1.RThreshold = 0
'Generate an OnComm event on each character received:
'MSComm1.RThreshold = 1

'The Input property stores binary data:
'MSComm1.InputMode = comInputModeBinary
'The Input property stores data as text:
MSComm1.InputMode = comInputModeText

'Disable parity replacement"
'MSComm1.ParityReplace = ""

'Properties related to transmitting:

MSComm1.OutBufferSize = 1024

'Generate no transmit OnComm event:
MSComm1.SThreshold = 0
'Generate an OnComm event when the transmit buffer
'has SThreshold bytes or fewer:
'MSComm1.SThreshold = 512

'Handshaking options:
MSComm1.Handshaking = comNone
'MSComm1.Handshaking = comXOnXoff
'MSComm1.Handshaking = comRTS
'MSComm1.Handshaking = comRTSXOnXOff

'Open the port.
MSComm1.PortOpen = True
'Return success or failure
fncInitializeComPort = MSComm1.PortOpen
End Function

Public Sub MSComm1_OnComm()
'Handles all Comm events
Dim ComEventMessage As String
Select Case MSComm1.CommEvent
    'Handle each event or error by placing
    'code below each case statement
    
    ' Events
    Case comEvCD
        ComEventMessage = "Change in the CD line."
    Case comEvCTS
        ComEventMessage = "Change in the CTS line."
    Case comEvDSR
        ComEventMessage = "Change in the DSR line."
    Case comEvRing
        ComEventMessage = "Change in the RI line."
     Case comEvReceive
        ComEventMessage = "Receive buffer has RThreshold number of characters."
     Case comEvSend
        ComEventMessage = "Transmit buffer has SThreshold number of characters."
     Case comEvEOF
        ComEventMessage = "EOF character (1Ah) received."
        
    'Errors
    Case comEventBreak
        ComEventMessage = "A Break was received."
    Case comEventCDTO
        ComEventMessage = "CD (RLSD) Timeout."
    Case comEventCTSTO
        ComEventMessage = "CTS Timeout."
    Case comEventDSRTO
        ComEventMessage = "DSR Timeout."
    Case comEventFrame
        ComEventMessage = "Framing Error"
    Case comEventOverrun
        ComEventMessage = "Overrun; data Lost."
    Case comEventRxOver
        ComEventMessage = "Receive buffer overflow."
    Case comEventRxParity
        ComEventMessage = "Parity Error."
    Case comEventTxFull
        ComEventMessage = "Transmit buffer full."
    Case comEventDCB
        ComEventMessage = "Unexpected error retrieving DCB."
End Select
'Use for debugging:
Debug.Print ComEventMessage
End Sub

